:- module(arbiter,[turniir/0, ruut/3]).
%:- module(arbiter,[t/0, ruut/3]).
:- dynamic ruut/3,ruut_old/3,võttis/1,siire/3,siire_1/3,moves_abi/2,valekäik/1.

%mustad(main). 	
%valged(main).	%%%%%%%%%%%%%%%% ainult testimise ajaks!!!!

% qcompile('C:/Users/Jüri/Desktop/Mina/Minu Programmid/Kabe/arbiiter.pl').
%===================================== Turniir ====================================
turniir:-
%t:-
	prepare,
             repeat,
	make_move(Color,ColorN),
	verify_turn(ColorN),			% kas käib lubatud nupuga ja kas käik korrektne?
	show_board0(ColorN),
	end_condition,
	announce_winner(Color),
%	korista,				% kommiteeritud välja testimise ajaks!!!!!!!!
!.
%======================== KÄIGU ÕIGUSE ANDMINE JA SOORITUS ===============================
make_move(Color,ColorNN):-
	 retract(colorCC(Color)),
	 players_turn0(Color,ColorN,Player),
	assert(colorCC(ColorN)),
	record_board_status,				% kopeeri laua seis enne käiku
	siire(_,Vottis,(X,Y)),	
	(Vottis=[],X1=0,Y1=0,ColorNN=ColorN;		% Kui eelnevalt ei võtnud, saab mängija X=0, Y=0
	millega_käia(ColorN,(X,Y),(X1,Y1),ColorNN)),	% Kui võttis, vaatab kas sama nupuga saab veel võtta
	retract(colorCC(_)),assert(colorCC(ColorNN)),
	correct_player(ColorNN,PlayerNN),
	 Turn=..[PlayerNN,ColorNN,X1,Y1],		% Kui sellega saab veel võtta, annab nupu X ja Y ja Color
	nl,write('KÄIB: '),write(Turn),nl,
	get0(_),
%	 Turn,
	!.				% Tee käik
%================= Vaatab kellele anda käimisõigus ===================
reset_color(10,1):- retract(colorCC(_)),assert(colorCC(1)),!.
reset_color(20,2):- retract(colorCC(_)),assert(colorCC(2)),!.
reset_color(Color,Color).

reset_color1(1,10).
reset_color1(2,20).
reset_color1(20,2).
reset_color1(10,1).
reset_color1(C,C).

correct_player(1,PlayerNN):-
	valged(PlayerNN),!.
correct_player(10,PlayerNN):-
	valged(PlayerNN),!.
correct_player(2,PlayerNN):-
	mustad(PlayerNN),!.
correct_player(20,PlayerNN):-
	mustad(PlayerNN).
%-------------------
players_turn0(Color,ColorN,Player):-
	võttis([]),
	players_turn(Color,ColorN,Player),!.	% pöördub algselt genereeritud fakti poole
players_turn0(Color,ColorN,Player):-		% Kui võttis ja saab veel võtta sama nupuga, jätkab sama mängija
	partner_color(Color,ColorP),
	players_turn(ColorP,_,Player),		% pöördub algselt genereeritud fakti poole
	siire(_,_,XY),
	kas_sai_tammiks(Color,XY,ColorN),!.
%----------------------
kas_sai_tammiks(1,(8,_),10):- !.		% valge sai tammiks
kas_sai_tammiks(2,(1,_),20):- !.		% must sai tammiks
kas_sai_tammiks(Color,_,Color).			% ei saanud tammiks
%----------------------
millega_käia(Color,(X,Y),(0,0),ColorNN):- 		% Kui ei saa edasi võtta, siis saab käiguõiguse vastane
	ruut_old(X,Y,Z),
	generate_moves((X,Y,Z),Moves),			% genereerime selle nupu legaalsed käigud
	findall(Võttis,(member([Võttis,_],Moves),	% kui leitud käikude hulgas võtmist ei ole?
	not(Võttis=[])),[]),
	partner_color(Color,ColorNN),!.
millega_käia(Color,(X,Y),(X,Y),ColorNN):-
	reset_color(Color,ColorNN),!.			% peab sama nupuga edasi võtma, millega võttis eelmisel käigul

%===================VERIFY: Käigu reeglitele vastavuse kontroll=======================
verify_turn(Color):-					% Võrdle ruut_old/3 ja ruut/3 fakte ja
	käiv_nupp(Color,(X,Y),Kuhu,Võttis),		% Leia mis nupp käis
	retract(siire_1(_,_,_)),
	retract(siire((X0,Y0),Võttis0,Kuhu0)),
	assert(siire_1((X0,Y0),Võttis0,Kuhu0)),		% Salvesta eelmine käik
	assert(siire((X,Y),Võttis,Kuhu)),		% Salvesta jooksev käik
	ruut_old(X,Y,Z),
	generate_all_legal_moves((X,Y,Z),Võttis),	% genereeri selle nupu legaalsed käigud
	moves_abi((X,Y,_),Moves),
	Käik=[Võttis,KuhuList],
	member(Käik,Moves),
	member(Kuhu,KuhuList),
	retractall(võttis(_)),
	retractall(moves_abi(_,_)),
	assert(võttis(Võttis)),!.
verify_turn(Color):-
	nl,write(['mängija ', Color, 'tegi vale käigu või jättis käimata']),
	assert(valekäik(Color)),
	retractall(moves_abi(_,_)),!.

käiv_nupp(Color,(X0,Y0),(X2,Y2),Võttis):-
	ruut_old(X0,Y0,Color),ruut(X0,Y0,0),		% leia käiv nupp
	ruut_old(X2,Y2,0), ruut(X2,Y2,ColorN),		% leia sihtruut
	kas_sai_tammiks(Color,(X2,Y2),ColorN),		% võtmisega võib saada tammiks
	partner_color(Color,ColorP),
	(sama_värv(ColorP,ColorPP),ruut_old(X1,Y1,ColorPP),ruut(X1,Y1,0),Võttis=(X1,Y1);Võttis=[]),!.
käiv_nupp(Color,(X0,Y0),(X2,Y2),Võttis):-		% kui nupp on juba tamm
	Color10 is Color * 10,
	ruut_old(X0,Y0,Color10),ruut(X0,Y0,0),		% leia käiv nupp
	ruut_old(X2,Y2,0), ruut(X2,Y2,Color10),		% leia sihtruut
	partner_color(Color,ColorP),
	(sama_värv(ColorP,ColorPP),ruut_old(X1,Y1,ColorPP),ruut(X1,Y1,0),Võttis=(X1,Y1);Võttis=[]),!.
%---------------------------
sama_värv(1,10).
sama_värv(10,1).
sama_värv(2,20).
sama_värv(20,2).
sama_värv(C,C).

%---------------------genereeri seisu kõik legaalsed käigud

generate_all_legal_moves((X,Y,Color),Võttis):-		% Kui eelmisel käigul võttis, proovib kas saab samaga veel
	not(Võttis=[]),					% Võttis ei tohi olla tühi
	ruut_old(X,Y,ColorN),
	generate_moves((X,Y,ColorN),Moves),
	findall([Võttis,Kuhu],(member([Võttis,Kuhu],Moves),not(Võttis=[])),MovesXY),	%Leia võtmisega käigud
	not(MovesXY=[]),
	assert(moves_abi((X,Y,ColorN),Moves)),!.
generate_all_legal_moves((_,_,Color),_):-		% Kas saab suva nupuga võtta, siis salvesta ainult võtmiskäike
	reset_color1(Color,ColorN),			% proovi nupu ja tammi värve
	ruut_old(X,Y,ColorN),
	generate_moves((X,Y,ColorN),Moves),		% genereerida käigud ühele nupule
%	generate_moves((X,Y,Color),Moves),
	findall([Võttis,Kuhu],(member([Võttis,Kuhu],Moves),not(Võttis=[])),MovesXY),	%Leia võtmisega käigud
	not(MovesXY=[]),
	assert(moves_abi((X,Y,ColorN),MovesXY)),
	fail.
generate_all_legal_moves((_,_,_),_):-			% Sai võtta ja rohkem ei otsi käike
	moves_abi(_,_),!.
generate_all_legal_moves((_,_,Color),_):-		% Kui ei saa üldse võtta, leia kõik muud käigud
	reset_color1(Color,ColorN),			% proovi nupu ja tammi värve
	ruut_old(X,Y,ColorN),
	generate_moves((X,Y,ColorN),Moves),
	assert(moves_abi((X,Y,ColorN),Moves)),
	fail.
generate_all_legal_moves((_,_,_),_).
%------------------------------------------------------------
%	Kõigi käikude genereerimine nupule (X0,Y0)
%-----------------------------------------------------------
generate_moves((X0,Y0,1), Moves):-		% Kui tavaline nupp ja valge
	ruut_old(X0,Y0,1),		% Kas niisugune nupp on üldse olemas?
	nupuga(X0, Y0,1,1,Moves),!.
generate_moves((X0,Y0,2), Moves):-		% Kui tavaline nupp ja must
	ruut_old(X0,Y0,2),		% Kas niisugune nupp on üldse olemas?
	nupuga(X0, Y0,2,-1,Moves),!.
generate_moves((X0,Y0,Value), Moves):-
	Value > 2,			% Kas nupp on tamm?
	ruut_old(X0,Y0,Value),		% Kas niisugune nupp on olemas?
	tammiga(X0,Y0,L0), list_to_set(L0,Moves),!. 
%	write((X0,Y0,Value)),write('   '),write(Moves),nl,nl.	% TESTIMISEKS!!!!
%===================== Tavalise nupu käigud antud positsioonilt====================================
nupuga(X0, Y0,Color,XSuund,Käigud):-
	vota_nupuga(X0,Y0,Color,(1,1), Käik1),					% Genereeri nupuga võimalikud võtmised suunas (1,1)
	vota_nupuga(X0,Y0,Color,(1,-1), Käik2),	append(Käik1,Käik2,Käik12),	% Genereeri nupuga võimalikud võtmised suunas (1,-1)
	vota_nupuga(X0,Y0,Color,(-1,1), Käik3),	append(Käik12,Käik3,Käik123),	% Genereeri nupuga võimalikud võtmised suunas (-1,1)
	vota_nupuga(X0,Y0,Color,(-1,-1), Käik4),append(Käik123,Käik4,Käik1234),	% Genereeri nupuga võimalikud võtmised suunas (-1,-1)
		(Käik1234=[],						% Kui vähemalt ühe on nupuga võetud, siis lihtsaid käike enam ei vaadata
	käi_nupuga(X0,Y0,Color,(XSuund,1),Käik5),
	käi_nupuga(X0,Y0,Color,(XSuund,-1),Käik6),
	append(Käik5,Käik6,Käigud);
	Käigud=Käik1234),!.
%------------------ nupuga võtmised-------------
vota_nupuga(X0,Y0,Color,(DX,DY), [[(X1,Y1),[(X2,Y2)]]]):-
	X1 is X0+DX, Y1 is Y0 + DY,      kas_laual(X1,Y1),
	X2 is X1 + DX, Y2 is Y1 + DY,    kas_laual(X2,Y2),
	partner_color(Color,Color1),
	ruut_old(X1,Y1,Color1),
	ruut_old(X2,Y2,0),!.
vota_nupuga(_,_,_,_, []).
%------------------ nupu tavalised käigud-------------
käi_nupuga(X0,Y0,_,(DX,DY),[[[],[(X1,Y1)]]]):-
	X1 is X0+DX, Y1 is Y0 + DY,      kas_laual(X1,Y1),
	ruut_old(X1,Y1,0),!.
käi_nupuga(_,_,_,_,[]).

%====================== Tammi käigud antud positsioonilt ==============================================
tammiga(X0, Y0,Käigud):-
	findall((X,Y), (ruut(X,Y,_), tingimus(X0,Y0,X,Y)), L0), delete(L0,(X0,Y0), Diagonals0),		% Leida ruudu (X0,Y0) diagonaalruudud
	list_to_set(Diagonals0, Diagonals),
	vota_tammiga((X0,Y0), Diagonals, VoetavadNupud, Post_posits),				% Kui saab võtta, tagastab võtmise järgsed positsioonid ja
	(Post_posits=[], findall((XX,YY), (member((XX,YY), Diagonals), ruut_old(XX,YY,0)), VabadRd),	% võetava nupu koordinaadid
	käi_tammiga([(X0,Y0)], VabadRd, Vabad0), delete(Vabad0, (X0,Y0), Vabad), 
	append([[]],[Vabad],Käigud0),Käigud=[Käigud0];	% kui ei, tagastab mis ruudud on nendest liikumiseks vabad
	Käigud=Post_posits).
%------------------ tammiga võtmised-------------
vota_tammiga((X0,Y0),Diagonals,VoetavadNupud,Post_posits):-						% Voetavad=[[(X,Y), Post_positions],...]
	findall((X,Y), (member((X,Y),Diagonals), voetav((X0,Y0),(X,Y))), VoetavadNupud),
	find_post_pos((X0,Y0),VoetavadNupud,Post_posits).						%

find_post_pos(_,[],[]).									% Leia võimalikud järelpositsioonid peale võtmist
find_post_pos((X0,Y0),[(X,Y)|VoetavadNupud], [[(X,Y),PostsXY]|Post_posits]):-
	Vx is sign(X-X0), Vy is sign(Y-Y0),
	X1 is X + Vx, Y1 is Y + Vy,
	find_post_pos1((X1,Y1),(Vx,Vy),PostsXY),
	find_post_pos((X0,Y0),VoetavadNupud,Post_posits).

find_post_pos1((X,Y),(Vx,Vy),[(X,Y)|PostsXY]):-
	ruut_old(X,Y,0),
	X1 is X + Vx, Y1 is Y + Vy,
	find_post_pos1((X1,Y1),(Vx,Vy),PostsXY).
find_post_pos1(_,_,[]).

voetav((X0,Y0),(X,Y)):-
	colorCC(Color),
	partner_color(Color,Vastase_varv),
	ruut_old(X,Y,Vastase_varv),
	Vx is sign(X-X0), Vy is sign(Y-Y0),
	X1 is X0 + Vx, Y1 is Y0 + Vy,
	kas_vahel_vabad((X1,Y1),(X,Y),(Vx,Vy)),
	X2 is X + Vx, Y2 is Y + Vy,	ruut_old(X2,Y2,0).			% kas järel vaba ruut?

kas_vahel_vabad((X,Y),(X,Y),_):- !.					% Kas võetava ja käidava nupu vahel on vabad ruudud?
kas_vahel_vabad((Xi,Yi),(X,Y),(Vx,Vy)):-
	ruut_old(Xi,Yi,0),
	Xi1 is Xi + Vx, Yi1 is Yi + Vy,
	kas_vahel_vabad((Xi1,Yi1),(X,Y),(Vx,Vy)).

%--------------- tingimused, mida tammi liikumisteed peavad rahuldama---------------------------
tingimus(X0,Y0,X,Y):-
	kas_laual(X0,Y0),
	X =:=Y+X0-Y0.
tingimus(X0,Y0,X,Y):-
	kas_laual(X0,Y0),
	X =:= -Y+(X0+Y0).

%--------------------------------Vabade ruutude leidmine, kuhu tamm saab käia-------------------------
% Front liigub pikki vabasid ruute nupust sammu kaupa  kaugemale ja tagastab vabade ruutude listi
%-------------------------------------------------------------------------------------------------------------
käi_tammiga([],_,[]):- !.
käi_tammiga(_,[],[]):- !.
käi_tammiga(Front,Space,Eligible):-
	subtract(Space,Front,RemainingSpace),
	findall((X,Y),constraint((X,Y),RemainingSpace,Front),NewFront),
	käi_tammiga(NewFront,RemainingSpace,Eligible0),
	append(Front,Eligible0,Eligible).

constraint((X,Y),RemainingSpace,Front):-
	member((X,Y),RemainingSpace),
	neighbourIn((X,Y),Front).

neighbourIn((X,Y), [(X1,Y1)|_]):-		% kas (X,Y)-l leidub hulgas Front vahetu naaber
	abs(abs(X) - abs(X1)) =:=1,
	abs(abs(Y) - abs(Y1)) =:=1,!.
neighbourIn((X,Y), [_|Front]):-
	neighbourIn((X,Y), Front),!.
%========================== END MAKE_MOVE==========================

end_condition:-
	valekäik(Color),!.
end_condition:-
	check_fp,
	reset_seis,
	fixpoint(yes).

%================== Kontrolli püsipunkti===========================
check_fp:-
    abolish(fixpoint/1),
    assert(fixpoint(yes)),
    ruut(X,Y,Color),
    check_fp1(X,Y,Color),
    fail.
check_fp.

check_fp1(X,Y,Color):-
    retract(ruut_o(X,Y,Color)),!.   		% Kas leidub samade parameetritega ruut
check_fp1(_,_,_):-
    retract(fixpoint(_)),
    assert(fixpoint(no)),!.

reset_seis:-
    abolish(ruut_o/3),
    ruut(X,Y,Color),
    assert(ruut_o(X,Y,Color)),
    fail.
reset_seis.

%=========================================================================
%-------------------------------------------------------------------------------------------------------------------
prepare:-
	mustad(Functor2),	assert(players_turn(1,2,Functor2)),
	valged(Functor1),	assert(players_turn(2,1,Functor1)),
	assert(siire_1((0,0),[],(0,0))),
	assert(siire((0,0),[],(0,0))),
	assert(arv(0)),
	abolish(colorCC/1),
	assert(colorCC(2)),	% %%%%%%%%%%%%%TESTIMISEKS
%	assert(colorCC(1)),	% %%%%%%%%%%%%%TESTIMISEKS
	reset_seis,
	assert(võttis([])),!.
%--------------
korista:-
	abolish(mustad/1), abolish(valged/1),
	retractall(players_turn(_,_,_)),
	!.
%--------------
kas_laual(X,Y):-
	1=< X, X=<8,
	1=< Y, Y=<8,!.
%-------------------------
partner_color(1, 2).
partner_color(1, 20).
partner_color(10, 2).
partner_color(10, 20).
partner_color(2, 1).
partner_color(2, 10).
partner_color(20, 1).
partner_color(20, 10).
%-------------


%============================= announce_winner =====================================
announce_winner(Color):-
    players_turn(_,Color,Winner),
    nl, write('The winner is program \"'),write(Winner), write('\"'),write(' playing with color '), write(Color),
    arv(NNN),nl,write('Total number of moves is '), write(NNN).
%-------------
record_board_status:-
	abolish(ruut_old/3),
	ruut(X,Y,Z), kas_laual(X,Y),
	assert(ruut_old(X,Y,Z)),
	fail.
record_board_status.

% ======================== Mängulaua seisu kuvamine =======================
show_board0(Color):-
	retract(arv(NN)), NN1 is NN + 1,assert(arv(NN1)),
	nl,nl,write('Move no '),write(NN1),write('--  Player\'s  '), write(Color),write(' turn:'),
	siire(Kust,Võttis,Kuhu),
	write(Kust),write('--'),
	write(Võttis),
	write('-->'),
	write(Kuhu),nl,
	show_board(1),!.
show_board0(_).

show_board(9):- !.
show_board(X):-
    write('|'), show_board1(X,1),   write('|'),nl,
    X1 is X + 1,!,
    show_board(X1).

show_board1(_,9):- !.
show_board1(X,Y):-
    (ruut(X,Y,Color), write(Color) ; write('   ')),
    Y1 is Y + 1,!,
    show_board1(X,Y1).


%---------MÄNGU ALGSEIS------------

% Valged
ruut(1,1,1).
ruut(1,3,1).
ruut(1,5,1).
ruut(1,7,1).
ruut(2,2,1).
ruut(2,4,1).
ruut(2,6,1).
ruut(2,8,1).
ruut(3,1,1).
ruut(3,3,1).
ruut(3,5,1).
ruut(3,7,1).
% Tühjad ruudud
ruut(4,2,0).
ruut(4,4,0).
ruut(4,6,0).
ruut(4,8,0).
ruut(5,1,0).
ruut(5,3,0).
ruut(5,5,0).
ruut(5,7,0).
% Mustad
ruut(6,2,2).
ruut(6,4,2).
ruut(6,6,2).
ruut(6,8,2).
ruut(7,1,2).
ruut(7,3,2).
ruut(7,5,2).
ruut(7,7,2).
ruut(8,2,2).
ruut(8,4,2).
ruut(8,6,2).
ruut(8,8,2).

/*
 ==============Mängija programmi vormistamise reeglid:=======================
 1. Programm peab olema vormistatud mooduli kujul
    	:- module(mooduli_nimi, mooduli_peapredikaat/3).
    		kus peapredikaadi parameetriks on selle programmi nuppude värv, X ja Y koordinaat
 2. Moodulis ei tohi olla defineeritud staatilisi fakte ruut/3 ja  definitsiooni :- dynamic ruut/3.
 3. Mängija programmist ei tohi väljuda fail-ga. Seetõttu on soovitav kasutada mängija peapredikaadi järgmist struktuuri:

	main_pgm(Color,X,Y):-
		...., !.
	main_pgm(_,_,_).

 4. Arbiiter salvestab seisu (ruut_old), annab juhtimise mängija programmile, saab käigu tulemuse, vaatab mis nupuga käidi. 
	kontrollib kas õige mängija nupp ja kas see nupp eksisteerib
 	genereerib ise sama nupu lubatud käikude hulga ja kontrollib kas käik sisaldub selles hulgas. 
	Kui käik on võtmisega ja sama nupuga saab veel võtta, siis arbiiter annab õiguse samale mängijale koos võtva nupu koordinaatidega. 
	Kui sama nupuga ei saa rohkem võtta, ei pea ka sama nupuga käima.
 	Kui ei olnud võtmist, on parameetrid X=Y=0 ja käia võib suvalise nupuga
5. Lõpetamistingimused: 
	5.1 Kui käik rikub reegkeid, võidab vastane. 
	5.2 Kui ei ole rohkem käike, võidab see, kes teeb viimase käigu. 
	5.3 Kui mõlema blokeerumisel käikude arv ja nuppude arv võrdne, siis viik.
 	5.4 Kui 10 käigu järel ei ole seis muutunud, siis viik.

===============Mängu ettevalmistamine====================
Käsurealt defineerida faktid:    assert(mustad(Predik_nimi1)), assert(valged(Prdik_nimi2)).
Testimisel: assert(mustad(main)), assert(valged(main)).
=================Mängu käivitamine============================
 Laadida esmalt mällu arbiter.pl ja seejärel mängijate programmide failid
 Kutsuda välja predikaat "turniir/0"
==========================================================
*/
/*
ruut(1, 7, 1).
ruut(2, 8, 1).
ruut(3, 1, 1).
ruut(5, 1, 0).
ruut(6, 8, 2).
ruut(7, 7, 2).
ruut(8, 6, 2).
ruut(8, 8, 2).
ruut(3, 5, 1).
ruut(5, 7, 2).
ruut(2, 4, 1).
ruut(1, 3, 0).
ruut(6, 2, 2).
ruut(4, 4, 1).
ruut(6, 6, 2).
ruut(7, 1, 2).
ruut(2, 2, 1).
ruut(1, 1, 0).
ruut(7, 5, 2).
ruut(8, 4, 0).
ruut(4, 8, 1).
ruut(4, 6, 0).
ruut(5, 5, 0).
ruut(7, 3, 0).
ruut(8, 2, 10).
ruut(3, 7, 1).
ruut(2, 6, 1).
ruut(1, 5, 0).
ruut(3, 3, 0).
ruut(4, 2, 0).
ruut(5, 3, 0).
ruut(6, 4, 1).
*/
/*
ruut(1, 7, 1).
ruut(2, 8, 1).
ruut(5, 1, 0).
ruut(6, 8, 2).
ruut(7, 7, 2).
ruut(8, 6, 2).
ruut(8, 8, 2).
ruut(3, 5, 1).
ruut(5, 7, 2).
ruut(2, 4, 1).
ruut(6, 2, 2).
ruut(4, 4, 0).
ruut(6, 6, 0).
ruut(7, 1, 2).
ruut(1, 1, 0).
ruut(8, 4, 0).
ruut(4, 8, 1).
ruut(4, 6, 0).
ruut(5, 5, 0).
ruut(7, 3, 0).
ruut(8, 2, 10).
ruut(3, 7, 1).
ruut(2, 6, 1).
ruut(1, 5, 0).
ruut(3, 3, 1).
ruut(7, 5, 0).
ruut(6, 4, 2).
ruut(5, 3, 0).
ruut(4, 2, 0).
ruut(3, 1, 2).
ruut(2, 2, 1).
ruut(1, 3, 0).
*/
%  TESTPÄRING: millega_käia(20,  (1, 3),  (C,C1 )).
/*

ruut(1,7,1).
ruut(2,6,1).
ruut(2,8,1).
ruut(3,1,20).
ruut(3,3,1).
ruut(3,7,1).
ruut(4,8,1).
ruut(6,8,2).
ruut(6,6,2).
ruut(7,7,2).
ruut(8,4,10).
ruut(8,6,10).
ruut(8,8,2).

ruut(5,1,0).
ruut(4,2,0).
ruut(5,3,0).
ruut(7,3,0).
ruut(6,4,0).
ruut(5,7,0).
ruut(5,5,0).
ruut(4,4,0).
ruut(1,1,0).
ruut(7,1,0).
ruut(6,2,0).
ruut(1,3,0).
ruut(2,2,0).
ruut(2,4,0).
ruut(1,5,0).
ruut(3,5,0).
ruut(4,6,0).
ruut(7,5,0).
ruut(8,2,0).
*/
%%%%%TESTid
t1:- retract(ruut(3,3,_)),retract(ruut(4,4,_)),assert(ruut(3,3,0)),assert(ruut(4,4,1)).
t2:- retract(ruut(6,2,_)),retract(ruut(5,3,_)), assert(ruut(6,2,0)),assert(ruut(5,3,2)).
t3x:- retract(ruut(2,2,_)),retract(ruut(3,3,_)), assert(ruut(2,2,0)),assert(ruut(3,3,1)).
t3:- retract(ruut(4,4,_)),retract(ruut(5,3,_)),retract(ruut(6,2,_)), assert(ruut(4,4,0)),assert(ruut(5,3,0)),assert(ruut(6,2,1)).
t5:- retract(ruut(6,8,_)),retract(ruut(5,7,_)),retract(ruut(4,6,_)), assert(ruut(6,8,0)),assert(ruut(5,7,0)),assert(ruut(4,6,10)).
